Subject: Re: [PATCH net-next stable] sctp: fully initialize sctp_outq in sctp_outq_init

From: Sergei Shtylyov <[email-masked]>
Date: Wed, 12 Jun 2013 17:51:08 +0400

Hello.

On 12-06-2013 16:59, Neil Horman wrote:

> In commit 2f94aabd9f6c925d77aecb3ff020f1cc12ed8f86, we modified

     Please also specify that commit's summary line in parens.

> sctp_outq_teardown to use sctp_outq_init to fully re-initalize the outq
> structure.  Steve West recently asked me why I removed the q->error = 0
> initalization from sctp_outq_teardown.  I did so because I was operating under
> the impression that sctp_outq_init would properly initalize that value for us,
> but it doesn't.  sctp_outq_init operates under the assumption that the outq
> struct is all 0's (as it is when called from sctp_association_init), but using
> it in __sctp_outq_teardown violates that assumption. We should do a memset in
> sctp_outq_init to ensure that the entire structure is in a known state there
> instead.

> Signed-off-by: Neil Horman <[email-masked]>
> Reported-by: "West, Steve (NSN - US/Fort Worth)" <[email-masked]>
> CC: Vlad Yasevich <[email-masked]>
> CC: [email-masked]
> CC: [email-masked]
> ---
>   net/sctp/outqueue.c | 7 +++----
>   1 file changed, 3 insertions(+), 4 deletions(-)
>
> diff --git a/net/sctp/outqueue.c b/net/sctp/outqueue.c
> index 32a4625..d8b6958 100644
> --- a/net/sctp/outqueue.c
> +++ b/net/sctp/outqueue.c
> @@ -206,6 +206,9 @@ static inline int sctp_cacc_skip(struct sctp_transport *primary,
>    */
>   void sctp_outq_init(struct sctp_association *asoc, struct sctp_outq *q)
>   {
> +

    Why empty line here?

> +	memset(q, 0, sizeof(struct sctp_outq));
> +

    sizeof(*q) would have been shorter...

WBR, Sergei